package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.MsgSendQueueHis;
import com.sa.ibiz.demo.demo.service.MsgSendQueueHisService;
import com.sa.ibiz.demo.demo.service.dto.MsgSendQueueHisSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/msgsendqueuehis")
public class MsgSendQueueHisResource
{
	@Autowired
	private MsgSendQueueHisService service;


	@PostMapping(value = "/remove")
	public ResponseEntity<MsgSendQueueHis> remove(@Validated @RequestBody MsgSendQueueHis data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列（历史）[remove]操作发生错误","MsgSendQueueHis",data.getMsgsendqueuehisid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<MsgSendQueueHis> update(@Validated @RequestBody MsgSendQueueHis data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列（历史）[update]操作发生错误","MsgSendQueueHis",data.getMsgsendqueuehisid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<MsgSendQueueHis> checkKey(@Validated @RequestBody MsgSendQueueHis data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列（历史）[checkKey]操作发生错误","MsgSendQueueHis",data.getMsgsendqueuehisid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<MsgSendQueueHis> get(@Validated @PathVariable String id){
		MsgSendQueueHis data=new MsgSendQueueHis();
		data.setMsgsendqueuehisid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("消息发送队列（历史）[get]操作发生错误","MsgSendQueueHis",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<MsgSendQueueHis> getDraft(@Validated @RequestBody MsgSendQueueHis data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列（历史）[getDraft]操作发生错误","MsgSendQueueHis","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<MsgSendQueueHis> create(@Validated @RequestBody MsgSendQueueHis data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列（历史）[create]操作发生错误","MsgSendQueueHis",data.getMsgsendqueuehisid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<MsgSendQueueHis>> searchDefaultPage(@Validated @RequestBody MsgSendQueueHisSearchFilter filter){
		Page<MsgSendQueueHis> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<MsgSendQueueHis>> listDefault(@Validated @RequestBody MsgSendQueueHisSearchFilter filter){
		List<MsgSendQueueHis> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
